<?php

namespace BayDOC\Tabs;

class TabEmail extends Tab
{

    public function print()
    {
        if ($this->entry->getRole() == 'admin') {
            if ($_GET['id_mail'] ?? false) {
                [$qb, $id] = explode('_', $_GET['id_mail']);
                if ($qb == 2)
                    $query = 'select subject, message, email_type,id_run from qb2_emails where id=$1';
                else
                    $query = 'select betreff, nachricht, email_type,null as id_run from qb_mails where id=$1';
                $res = pg_query_params(
                    $this->context->getDbConn(),
                    $query,
                    [$id]
                );
                if (pg_num_rows($res)) {
                    [$_POST['subject'], $_POST['message'], $_POST['email_type'], $_POST['id_run']] = pg_fetch_row($res, 0);
                    $_GET['aktion'] = 'edit';
                }
            }

            if ($_GET['aktion'] ?? false) {
                $mailer = new \BayDOC\Util\Mail($this->context);
                $form = $mailer->getEmailForm("tab=email&id=" . $this->entry->getId());
                if ($_POST['id_run'] ?? false) {

                }
                [$attachment] = pg_fetch_row(
                    pg_query_params(
                        $this->context->getDbConn(),
                        'select get_attachments($1,$2)',
                        [$_POST['id_run'], $this->context->org_folder]
                    ),0
                );
                if ($attachment) {
                    $form->addField(new \BayCMS\Field\Comment($this->context,'attachment','<b>Attechments</b><br/>' . $attachment));
                    $form->addField(new \BayCMS\Field\Hidden($this->context,'id_run',type:'int'));
                }
                if ($_GET['aktion'] == 'save') {
                    $error = $form->setValues($_POST);
                    if ($error)
                        $_GET['aktion'] = "edit";
                }

                if ($_GET['aktion'] == 'save') {
                    $mailer->sendMail(
                        $this->entry->getRow()['email'],
                        $_POST['subject'],
                        $_POST['message'],
                        [],
                        $_POST['sender'],
                        [$this->entry->getId()],
                        $_POST['email_type'],
                        $_POST['id_run']??null
                    );
                    $GLOBALS['TE']->printMessage('E-Mail gesendet.');
                    unset($_GET['aktion']);
                }

                if (isset($_GET['aktion'])) {
                    if (isset($_POST['subject']))
                        $form->setValues($_POST);
                    echo $form->getForm('Neue E-Mail');
                }
            }
            if (!isset($_GET['aktion'])) {
                echo $GLOBALS['TE']->getActionLink('?tab=email&aktion=edit&id=' . $this->entry->getId(), 'Neue E-Mail', '', 'new');

                $sform = new \BayCMS\Fieldset\Form(
                    $this->context,
                    qs: "tab=email&id=" . $this->entry->getId()
                );
                $sform->addField(new \BayCMS\Field\TextInput($this->context, 'search', placeholder: 'search'));
                $sform->setValues($_GET);
                echo $sform->getSearchForm();

                $where = "true";
                if ($_GET['search'] ?? '') {
                    $where = " t.message ilike '%" . addslashes($_GET['search']) . "%'";
                }

                $list = new \BayCMS\Fieldset\BayCMSList(
                    $this->context,
                    "(select '1_'||id as id,wann as sendtime, 'DATUM: <b>'||to_char(m.wann,'DD.MM.YYYY HH24:MI')||'</b><br/>AN: <b>'||m.an||'</b><br/>BETREFF: <b>'||m.betreff||'</b>
			<br/><br/>'||case when m.email_type='text' then replace(m.nachricht,E'\\n','<br/>') else m.nachricht end||'<br/><br/>'||get_attachments(id_contact_run,'" . $this->context->org_folder . "')
            as message from qb_mails m where m.id_obj=" . $this->entry->getId() . "
            union
            select '2_'||id as id,sendtime, 'DATUM: <b>'||to_char(m.sendtime,'DD.MM.YYYY HH24:MI')||'</b><br/>AN: <b>'||m.to_address||'</b><br/>BETREFF: <b>'||m.subject||'</b>
			<br/><br/>'||case when m.email_type='text' then replace(m.message,E'\\n','<br/>') else m.message end||'<br/><br/>'||get_attachments(id_run,'" . $this->context->org_folder . "')
            as message from qb2_emails m where m.id_obj=" . $this->entry->getId() . "
            ) t",
                    $where,
                    step: 5,
                    offset: $_GET['table1offset'] ?? 0,
                    qs: "tab=email&id=" . $this->entry->getId(),
                    order_by: ['sendtime desc'],
                    jquery_row_click: true,
                    id_query: 't.id',
                    id_name: 'id_mail'
                );
                $list->addField(new \BayCMS\Field\TextInput($this->context, 'message', 'Nachricht'));
                echo $list->getTable();
            }

        }

    }

}